import { QueryKey, UseQueryReturnType, UseQueryOptions, QueryFunctionContext } from '@tanstack/vue-query';
import { AppRoute, AppRouteMutation, AreAllPropertiesOptional, ClientArgs, ClientInferRequest, PartialClientInferRequest } from '@ts-rest/core';
import { DataResponse, ErrorResponse } from './common';
export type DataReturnQuery<TAppRoute extends AppRoute, TClientArgs extends ClientArgs, TArgs = PartialClientInferRequest<TAppRoute, TClientArgs>> = AreAllPropertiesOptional<TArgs> extends true ? <TData = DataResponse<TAppRoute>>(queryKey: QueryKey, args?: (context: QueryFunctionContext<QueryKey>) => TArgs, options?: UseQueryOptions<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, TData>) => UseQueryReturnType<TData, ErrorResponse<TAppRoute>> : <TData = DataResponse<TAppRoute>>(queryKey: QueryKey, args: (context: QueryFunctionContext<QueryKey>) => TArgs, options?: UseQueryOptions<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, TData>) => UseQueryReturnType<TData, ErrorResponse<TAppRoute>>;
export declare const getRouteUseQuery: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs) => (queryKey: QueryKey, args?: ((context: QueryFunctionContext<QueryKey>) => ClientInferRequest<AppRouteMutation, ClientArgs>) | undefined, options?: UseQueryOptions<DataResponse<TAppRoute>> | undefined) => UseQueryReturnType<DataResponse<TAppRoute>, unknown>;
